unit WindowsVersions;

interface

Uses
    SysUtils,
    Windows;

    function GetProductInfo(dwOSMajorVersion, dwOSMinorVersion, dwSpMajorVersion, dwSpMinorVersion: DWORD; out pdwReturnedProductType: DWORD): BOOL stdcall; external kernel32;

    function RunningOnWindows10S: Boolean;
    function RunningOnWindows10AndAbove: Boolean;

implementation

function RunningOnWindows10S: Boolean;
const
    PRODUCT_CLOUD = $000000B2;  //* Windows 10 S
    PRODUCT_CLOUDN = $000000B3; //* Windows 10 S N
    PRODUCT_CORE = $00000065;   //* Windows 10 Home
var
    pdwReturnedProductType: DWORD;
begin
    Result := False;
    if GetProductInfo(10, 0, 0, 0, pdwReturnedProductType) then begin
        Result := (pdwReturnedProductType = PRODUCT_CLOUD) OR (pdwReturnedProductType = PRODUCT_CLOUDN);
    end;
end;

function RunningOnWindows10AndAbove: Boolean;
begin
    Result := Win32MajorVersion >= 10;
end;

end.
